set term ^ ;
--create exception listudf_test_error 'listudf test failed'^
create table listudf_test_tbl (name varchar(1024)) ^
commit^
insert into listudf_test_tbl values
  ('123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF'||
  '123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF123456789ABCDEF')^

execute block as
declare variable i int;
begin
i=2;
while (i<=15) do
  begin
  insert into listudf_test_tbl values (:i);
  i=i+1;
  end
end^

commit^


create or alter procedure listudf_test_proc
returns (
    v varchar(1024))
as
declare variable h integer;
declare variable i integer;
declare variable flg integer;
declare variable name varchar(1024);
declare variable nm varchar(1024);
declare variable errmsg varchar(100);
begin
while (1=1) do begin -- one pass only, emulating 'goto'
  h = createlist(0); -- argument is ignored
  ErrMsg = 'OK';
  if (h=-1) then begin ErrMsg = 'Creating list error'; break; end
  Flg = 0;
  for select name from listudf_test_tbl order by name into :name do begin
    i = listadd(h, name);
    if (i <> 0) then
      Flg = -1;
    end
  if (Flg <> 0) then begin ErrMsg = 'Add list error'; break; end
  Flg = listinsert(h,10, 'Test') + listinsert(h,11, 'Test1');
  if (Flg <> 0) then begin ErrMsg = 'Insert list error'; break; end
  Flg = listcount(h);
  if (Flg<>17) then begin ErrMsg = 'List count error'; break; end
  name = listget(h,10);
  if (name is null) then begin ErrMsg = 'Get list error'; break; end
  if (name <> 'Test') then begin ErrMsg = 'Insert/Get list error'; break; end
  i = listfind(h, 'Test');
  if (i <> 10) then begin ErrMsg = 'Find list error'; break; end
  Flg = listexchange(h,10,11);
  if (Flg <> 0) then begin ErrMsg = 'Exchange list error'; break; end
  name = listget(h,10);
  if (name is distinct from 'Test1') then begin ErrMsg = 'Exchange list error 2'; break; end
  Flg = listset(h, 10, 'Test 1');
  if (Flg <> 0) then begin ErrMsg = 'Set list error'; break; end
  name = listget(h,10);
  if (name is distinct from 'Test 1') then begin ErrMsg = 'Set list error 2'; break; end
  Flg = listclear(h);
  if (Flg <> 0) then begin ErrMsg = 'Clear list error'; break; end
  for select name from listudf_test_tbl order by name desc into :nm  do
    i = listadd(h, nm);
  Flg = listsort(h);
  if (Flg <> 0) then begin ErrMsg = 'Sort list error'; break; end
  i = 0;
/* -- uncomment this to watch list sorted
  while (i<listcount(h)) do begin
    suspend;
    i = i + 1;
  end    */
  break;
end
Flg = deletelist(h);
if (Flg <> 0) then ErrMsg = ErrMsg||' delete List error';
v = ErrMsg;
suspend;
/* if (ErrMsg <> 'OK') then begin
  exception listudf_test_error ErrMsg;
  v = ErrMsg;
  suspend;
end */
end
^

commit^
select * from listudf_test_proc^
commit^
drop procedure listudf_test_proc^
commit^
drop table listudf_test_tbl^
commit^
--drop exception listudf_test_error ^
--commit^
set term ; ^

